/**
 * Created by xiaoxiaosu on 17/3/10.
 */
var express =require('express'),
    bodyParser = require('body-parser'),
    jsonfile = require('jsonfile'),
    url = require('url'),
    cors = require('cors'),
    _ = require('underscore'),
    path = require('path')

function watch(dbname,port) {
    var app = express();
    var database
    if(/\.js$/.test(dbname)){
        var p = path.join(__dirname,dbname)
        database = require(p)()
    }else {
        console.log(dbname)
        database = jsonfile.readFileSync(dbname)
    }

    app.use(bodyParser.urlencoded({ extended: false }))
    app.use(cors())
    app.all('*',function (req, res) {


        var pathname = url.parse(req.originalUrl).pathname.replace(/^\//,'').replace(/$\//,'').split('/')
        var query = req.query
        var method = req.method

        console.log(req.originalUrl,req.method)


        var table = pathname[0]

            if(!database[table]){

                return res.send({
                    error:'table not exists'
                })
            }

            var get = req.method == 'GET',
            post = req.method == 'POST',
            patch = req.method == 'PATCH',
            put = req.method == 'PUT',
            Delete = req.method == 'DELETE',
            getAll = pathname.length == 1,
            getOne = pathname.length == 2,
            itemId = pathname.length >1 ? pathname[1] : 0;



            var page = query._page || 1,limit = query._limit || database[table].length,
            start = query._start || (function () {
                console.log(database[table].length,limit,page)
                    return limit*(page-1) <0 ? 0 : limit*(page-1)
                })(),
            end = query._end || (function () {
                    return limit*page > database[table].length ? database[table].length : limit*page
            })()
            var confidion = (function (query) {
                var obj = {
                    like:{},
                    is:{},
                    gt:{},
                    lt:{}
                }

                for(var key in query){
                    var page = ['_start','_end','_page','_limit']

                    if(page.indexOf(key)==-1){
                        if(/_like$/.test(key)){
                            obj.like[key] = query[key]
                        }else if(/_gt$/.test(key)){
                            obj.gt[key] = query[key]
                        }else if(/_lt$/.test(key)){
                            obj.lt[key] = query[key]
                        }else {
                            obj.is[key] = query[key]
                        }
                    }
                }
                return obj
        })(query)


        if(itemId == 0 && !getAll){
            if(getOne || patch || Delete || put){
                return res.send({'error':'this request metod need a itemid'})
            }
        }

        if(get && getAll){

            var data = []

            // 分页过滤
            for(var i=start;i<end;i++){
                data.push(database[table][i])
            }
            // 匹配
            if(_.keys(confidion.is)){
                var d = []
                for(var i=0;i<data.length;i++){
                    var bool = true
                    for(var key in confidion.is){
                        console.log(data[i][key] , confidion.is[key])
                        if(data[i][key] != confidion.is[key]){
                            bool = false
                        }
                    }
                    if(bool){
                        d.push(data[i])
                    }
                }
                data = d
            }


            res.send(data)
        }

        if(get && getOne){

            var item = database[table].find(function (obj) {
                return obj.id == itemId
            })

            if(item){
                res.send(item)
            }else {
                res.send({
                    error:'item not exists'
                })
            }
        }


        if(post){
            if(database){
                req.body.id = database[table][database[table].length-1].id +1
                database[table].push(req.body)

                jsonfile.writeFileSync(dbname,database,{spaces: 4})

                database = jsonfile.readFileSync(dbname)
                res.send(database[table])
            }else {
                res.send({
                    error:'table not exists'
                })
            }
        }

        if(patch){
            var o
            database[table] = database[table].map(function (obj) {
                if(obj.id == itemId){
                    o = Object.assign({},obj,req.body)
                    return o
                }else {
                    return obj
                }
            })
            jsonfile.writeFileSync(dbname,database,{spaces: 4})
            res.send(o)

        }

        if(put){
            var o
            database[table] = database[table].map(function (obj) {
                if(obj.id == itemId){
                    o = req.body
                    o.id = obj.id
                    return o
                }else {
                    return obj
                }
            })
            jsonfile.writeFileSync(dbname,database,{spaces: 4})
            res.send(o)
        }
        if(Delete){
            var o = database[table].find(function (obj) {
                return obj.id == itemId
            })
            if(o){
                database[table] = database[table].filter(function (obj) {
                    return obj.id != itemId
                })
                jsonfile.writeFileSync(dbname,database,{spaces: 4})
                res.send(o)

            }else {
                res.send({error:'item not found'})
            }
        }

    })
    app.listen(port,function () {
        console.log('server start')
    })
}

module.exports = watch